routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

Use App\Http\Controllers\Admin\UserController as AdminUserController;
Use App\Http\Controllers\Admin\CommentController as AdminCommentController;
Use App\Http\Controllers\Admin\PictureController as AdminPictureController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::middleware('language')->group(function () {

    Auth::routes();
    Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('pictures', \App\Http\Controllers\PictureController::class)->except('edit', 'update');

    Route::resource('users', \App\Http\Controllers\UserController::class)->only('show', 'edit', 'update');

    Route::resource('comments', \App\Http\Controllers\CommentController::class)->except('index', 'create');






Route::prefix('admin')->name('admin.')->middleware(['auth', 'is_admin'])->group(function () {
    Route::resources([
        'users' => AdminUserController::class,
        'comments' => AdminCommentController::class,
        'pictures' => AdminPictureController::class
    ]);
});


Route::post('/admin/{user}/admin', [AdminUserController::class, 'admin'])->name('admin.users.admin');

});
Route::get('language/{local}', [\App\Http\Controllers\LanguageSwitchController::class, 'switcher'])->name('language.switcher')->where('locale', 'en|ru|es|fr|kg');

app/Models/Picture.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

/**
 * @method static find($input)
 */
class Picture extends Model
{
    use HasFactory;

    protected $fillable = ['name', 'picture', 'user_id'];

    /**
     * @return HasMany
     */
    public function comments()
    {
        return $this->hasMany(Comment::class);
    }

    /**
     * @return BelongsTo
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/Admin/PictureController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\AdminPicturesTableEditRequest;
use App\Http\Requests\AdminPicturesTableStoreRequest;
use App\Models\Picture;
use App\Models\User;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class PictureController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index()
    {
        $pictures = Picture::all();
        return view('admin.pictures.index', compact('pictures'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|View
     */
    public function create()
    {
        $users = User::all();
        return view('admin.pictures.create', compact('users'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param AdminPicturesTableStoreRequest $request
     * @return RedirectResponse
     */
    public function store(AdminPicturesTableStoreRequest $request)
    {
        $data = $request->all();
        $file = $request->file('picture');
        if (!is_null($file)) {
            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;
        }
        $picture = new Picture($data);
        $picture->save();
        return redirect()->route('admin.pictures.index')->with('success', __('Successfully created'));
    }

    /**
     * Display the specified resource.
     *
     * @param Picture $picture
     * @return Application|Factory|View
     */
    public function show(Picture $picture)
    {
        return view('admin.pictures.show', ['picture' => $picture]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param Picture $picture
     * @return Application|Factory|View
     */
    public function edit(Picture $picture)
    {
        $users = User::all();
        return view('admin.pictures.edit', ['picture' => $picture], compact('users'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param AdminPicturesTableEditRequest $request
     * @param Picture $picture
     * @return RedirectResponse
     */
    public function update(AdminPicturesTableEditRequest $request, Picture $picture)
    {
        $data = $request->all();
        if ($request->hasFile('picture')) {
            $file = $request->file('picture');
            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;
        }
        $picture->update($data);
        return redirect()->route('admin.pictures.index')->with('success', __('Successfully created'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Picture $picture
     * @return RedirectResponse
     */
    public function destroy(Picture $picture)
    {
        $picture->delete();
        return redirect()->back()->with('success', __('Successfully deleted'));
    }
}

app/Http/Controllers/Api/PictureController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Resources\PictureResource;
use App\Models\Picture;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;

class PictureController extends Controller
{
    /**
     * ArticleController constructor.
     */
    public function __construct()
    {
        return $this->middleware('auth:api');
    }
    /**
     * Display a listing of the resource.
     *
     * @return AnonymousResourceCollection
     */
    public function index()
    {
        $pictures = Picture::paginate(4);
        return PictureResource::collection($pictures);
    }
}

app/Http/Controllers/PictureController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PicturesTableStoreRequest;
use App\Models\Picture;
use App\Models\User;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Support\Facades\Auth;

class PictureController extends Controller
{

    /**
     * PictureController constructor.
     */
    public function __construct()
    {
        return $this->middleware('auth')->only('create');
    }

    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View
     */
    public function index()
    {
        $pictures = Picture::orderByDesc('created_at')->paginate(4);
        return view('client.pictures.index', compact('pictures'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|View
     */
    public function create()
    {
        return view('client.pictures.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param PicturesTableStoreRequest $request
     * @return RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function store(PicturesTableStoreRequest $request)
    {
        $this->authorize('create', User::class);
        $data = $request->all();
        $file = $request->file('picture');
        if (!is_null($file)) {
            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;
        }
        $picture = new Picture($data);
        $picture->user_id = Auth::id();
        $picture->save();
        return redirect()->route('users.show', ['user' => Auth::user()])->with('success', __('Successfully created'));
    }

    /**
     * Display the specified resource.
     *
     * @param Picture $picture
     * @return Application|Factory|View
     */
    public function show(Picture $picture)
    {
        $grade = round($picture->comments()->avg('grade'), 2);
        $comments = $picture->comments()->latest()->get();
        return view('client.pictures.show', ['picture' => $picture], compact('grade', 'comments'));
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param Picture $picture
     * @return RedirectResponse
     */
    public function destroy(Picture $picture)
    {
        $this->authorize('delete', $picture);
        $picture->delete();
        return redirect()->route('users.show', ['user' => Auth::user()])->with('success', __('Successfully deleted'));
    }
}

resources/views/admin/pictures/create.blade.php
@extends('layouts.app')
@section('content')
    <h3 class="mb-3">{{__('Create picture')}}</h3>
    <form action="{{route('admin.pictures.store')}}" method="post" enctype="multipart/form-data">
        @csrf
        <div class="input-group mb-3">
            <span class="input-group-text" id="name">{{__('Name')}}</span>
            <input id="name" name="name" type="text" class="form-control @if($errors->has('name')) is-invalid @endif" placeholder="Username" aria-label="Username" aria-describedby="name">

        </div>
        @error('name')
        <p class="text-danger">{{$message}}</p>
        @enderror
        <div class="mb-3">
            <label for="picture" class="form-label @if($errors->has('picture')) is-invalid @endif">{{__('Picture')}}</label>
            <input name="picture" class="form-control" type="file" id="picture">
        </div>
        @error('picture')
        <p class="text-danger">{{$message}}</p>
        @enderror
        <select name="user_id" class="form-select mb-3 w-25 @if($errors->has('user_id')) is-invalid @endif"
                aria-label="Default select example">
            @foreach($users as $user)
                <option value={{$user->id}}>{{$user->name}}</option>
            @endforeach
        </select>
        @error('user_id')
        <p class="text-danger">{{$message}}</p>
        @enderror
        <div class="form-group">
            <button type="submit" class="btn btn-primary">{{ __('Save') }}</button>
        </div>
    </form>
@endsection

resources/views/admin/pictures/edit.blade.php
@extends('layouts.app')
@section('content')
    <h3 class="mb-3">{{__('Create picture')}}</h3>
    <form action="{{route('admin.pictures.update', ['picture' => $picture])}}" method="post" enctype="multipart/form-data">
        @csrf
        @method('PUT')
        <div class="input-group mb-3">
            <span class="input-group-text" id="name">{{__('Name')}}</span>
            <input value="{{$picture->name}}" id="name" name="name" type="text" class="form-control @if($errors->has('name')) is-invalid @endif" placeholder="Username" aria-label="Username" aria-describedby="name">
        </div>
        @error('name')
        <p class="text-danger">{{$message}}</p>
        @enderror
        <div class="mb-3">
            <label for="picture" class="form-label @if($errors->has('picture')) is-invalid @endif">{{__('Picture')}}</label>
            <input name="picture" class="form-control" type="file" id="picture">
        </div>
        @error('picture')
        <p class="text-danger">{{$message}}</p>
        @enderror
        <select name="user_id" class="form-select mb-3 w-25 @if($errors->has('user_id')) is-invalid @endif"
                aria-label="Default select example">
            @foreach($users as $user)
                <option @if($picture->user_id == $user->id) selected @endif value={{$user->id}}>{{$user->name}}</option>
            @endforeach
        </select>
        @error('user_id')
        <p class="text-danger">{{$message}}</p>
        @enderror
        <div class="form-group">
            <button type="submit" class="btn btn-primary">{{ __('Save') }}</button>
        </div>
    </form>
@endsection

resources/views/admin/pictures/index.blade.php
@extends('layouts.app')
@section('content')
    @include('admin.navbar.navbar')


    <div>
        <h4>{{__('Create new picture')}} <a class="btn btn-outline-primary" href="{{route('admin.pictures.create')}}">{{__('Create')}}</a></h4>
    </div>

    <table class="table table-dark">
        <thead>
        <tr>
            <th scope="col">ID</th>
            <th scope="col">{{__('Author')}}</th>
            <th scope="col">{{__('Name')}}</th>
            <th scope="col">{{__('Picture')}}</th>
            <th scope="col">{{__('Actions')}}</th>
        </tr>
        </thead>
        <tbody>
        @foreach($pictures as $picture)
            <tr>
                <th scope="row">{{$picture->id}}</th>
                <td>{{$picture->user->name}}</td>
                <td>{{$picture->name}}</td>
                <td><img style="width: 100px; height: 100px;" src="{{asset('/storage/' . $picture->picture)}}" alt="{{$picture->picture}}"></td>
                <td>
                    <div style="display: flex;">
                        <a class="btn btn-outline-info"
                           href="{{route('admin.pictures.edit', ['picture' => $picture])}}">{{__('Edit')}}</a>
                        <a class="btn btn-outline-warning mx-3" href="{{route('admin.pictures.show', ['picture' => $picture])}}">
                            {{__('Show')}}
                        </a>
                        <form method="post" action="{{route('admin.pictures.destroy', ['picture' => $picture])}}">
                            @method('delete')
                            @csrf
                            <button type="submit" class="btn btn-outline-danger">{{__('Delete')}}</button>
                        </form>
                    </div>
                </td>
            </tr>
        @endforeach
        </tbody>
    </table>
@endsection

resources/views/admin/pictures/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="card" style="width: 18rem;">
        <img src="{{asset('/storage/' . $picture->picture)}}" class="card-img-top" alt="{{$picture->picture}}">
        <div class="card-body">
            <h5 class="card-title">{{__('Author')}} : {{$picture->user->name}}</h5>
           <p>{{__('Name')}}: {{$picture->name}}</p>
        </div>
    </div>
@endsection